image: node:20-alpine

# PLACEHOLDER

stages:
  - install
  - build
  - test
  - deploy

include:
  - template: Jobs/SAST.gitlab-ci.yml

install-job:
  stage: install
  script:
    - npm install
  cache:
    key:
      files:
        - package-lock.json
    paths:
      - node_modules/

build-job:
  stage: build
  needs: ["install-job"]
  script:
    - npm run build
  cache:
    policy: pull
    key:
      files:
        - package-lock.json
    paths:
      - node_modules/
  artifacts:
    expire_in: 1 week
    paths:
      - build
      - .firebaserc
      - firebase.json

unit-tests:
  stage: test
  needs: ["install-job"]
  script:
    - npm run test || true
  cache:
    policy: pull
    key:
      files:
        - package-lock.json
    paths:
      - node_modules/
  artifacts:
    paths:
      - coverage/
  coverage: '/All files[ ]*\|[^|]*\|[^|]*\|[^|]*\|[^|]*\|[^|]*\|[^|]*\|(\d+\.\d+)/'

pages:
  stage: deploy
  script:
    - echo 'Deploying to GitLab Pages'
  artifacts:
    paths:
      - public
  rules:
    - if: $CI_COMMIT_BRANCH == $CI_DEFAULT_BRANCH
      when: always


deploy-job:
  stage: deploy
  needs: ["build-job"]
  image: andreysenov/firebase-tools:latest
  cache:
    policy: pull
    key:
      files:
        - package-lock.json
    paths:
      - node_modules/
  script:
    - npm run build
    - firebase deploy --token $FIREBASE_TOKEN

docker-build-job:
  stage: deploy
  needs: ["deploy-job"]
  image: docker:20.10.21-alpine3.16
  services:
    - docker:20.10.21-dind-alpine3.16
  before_script:
    - docker login -u "$DOCKER_USER" -p "$DOCKER_PASSWORD" "$DOCKER_REGISTRY"
  script:
    - docker build --pull -t "$DOCKER_IMAGE" .
    - docker push "$DOCKER_IMAGE"

deploy-to-vercel:
  stage: deploy
  needs: ["deploy-job"]
  image: node:20-alpine
  rules:
    - if: "$CI_COMMIT_BRANCH == 'prod'"
      when: always
  script:
    - npm install -g vercel
    - vercel --prod --token "$VERCEL_TOKEN" --yes
  environment:
    name: production